import { Color } from '@pilotlab/data';
import { IPromise } from '@pilotlab/result';
import { Signal } from '@pilotlab/signals';
import { BlurQuality } from './blur';
export declare abstract class ImagerBase {
    constructor(image?: (HTMLImageElement | HTMLCanvasElement | HTMLVideoElement | Blob | File | string));
    protected p_initialize(image: (HTMLImageElement | HTMLCanvasElement | HTMLVideoElement | Blob | File | string)): void;
    readonly isLoaded: boolean;
    protected p_isLoaded: boolean;
    readonly width: number;
    readonly height: number;
    protected p_imageWidth: number;
    protected p_imageHeight: number;
    readonly image: HTMLImageElement;
    protected p_image: HTMLImageElement;
    readonly canvas: HTMLCanvasElement;
    readonly context: CanvasRenderingContext2D;
    readonly dataUrl: string;
    readonly blob: IPromise<Blob>;
    readonly blurRadius: number;
    protected p_blurRadius: number;
    loaded: Signal<ImagerBase>;
    blurred: Signal<number>;
    protected p_loadImage(src: string): HTMLImageElement;
    protected p_initializeImage(image: HTMLImageElement | HTMLCanvasElement | HTMLVideoElement): void;
    drawToCanvas(context: CanvasRenderingContext2D, x?: number, y?: number, width?: number, height?: number): void;
    getPalette(colorCount?: number): Color[];
    getDominantColor(): Color;
    getAverageColor(): Color;
    blur(radius: number, quality?: BlurQuality, isBlurAlphaChannel?: boolean): void;
}
export default ImagerBase;
